﻿using System;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Threading;


namespace WpfApp1
{
    public partial class MainWindow : Window
    {
        string[] arr = { "a1", "a2", "trump" };
        int contaTempo = 0;
        int placar = 0;
        Brush statusTxtColor;
        DispatcherTimer timer = new DispatcherTimer();
        
        public MainWindow()
        {
            InitializeComponent();
            HabilitaCarta(false);
            txtStatus.Text = "";
            timer.Tick += Timer_Tick;
            timer.Interval = new TimeSpan(0,0,0,0,100);
            qLbl1.Visibility = qLbl2.Visibility = qLbl3.Visibility = Visibility.Collapsed;
            carta_0.Source = carta_1.Source = carta_2.Source = GetImagem("back");            
        }

        private void Timer_Tick(object sender, EventArgs e)
        {
            defineCarta();
        }

        //Define as cartas
        private void defineCarta()
        {
            contaTempo++;
            Embaralhar(arr);
            if (contaTempo < 8)
            {
                AbreCarta();
            }
            else
            {
                EncerraEmbaralhar();
            }
        }

        //Pega as imagens
        private BitmapImage GetImagem(string img)
        {
            BitmapImage image = new BitmapImage();
            image.BeginInit();
            image.UriSource = new Uri("imagens/" + img + ".png",UriKind.Relative);
            image.EndInit();
            return image;
        }

        // Encerra o embaralhamento
        private void EncerraEmbaralhar()
        {
            carta_0.Source = carta_1.Source = carta_2.Source = GetImagem("back");
            qLbl1.Visibility = qLbl2.Visibility = qLbl3.Visibility = Visibility.Visible;
            txtStatus.Text = "Onde esta o Trump ?";
            timer.Stop();
            contaTempo = 0;
            btnIniciar.IsEnabled = true;
            HabilitaCarta(true);
        }

        //Embaralha o array
        private void Embaralhar( string[] array)
        {
            Random random = new Random();
            int n = array.Length;  
            for (int i = 0; i < n;  i++) 
            {               
                int r = i + random.Next(n - i); 
                string t = array[r];  
                array[r] = array[i];
                array[i] = t;
            }
            arr = array;
        }     

        //evento click da carta
        private void Image_MouseDown(object sender, MouseButtonEventArgs e)
        {
            AbreCarta();
            HabilitaCarta(false);
            Image carta =(Image) sender;
            char[] splitChar =  { '_' };
            string[] numeroString = carta.Name.Split(splitChar);
            int numeroCarta = int.Parse(numeroString[1]);
            VerificaResultado(numeroCarta);          
        }

        // Verifica o resultado
        private void VerificaResultado(int numero)
        {
            string resultado = "";
           
            if (arr[numero] == "trump")
            {
                statusTxtColor = Brushes.GreenYellow;
                resultado = "PARABÉNS... Achou o Trump !!";
                placar += 10;
            }
            else
            {
                statusTxtColor = Brushes.Yellow;
                resultado = "ERROU... Tente outra vez!!";
                placar -= 5;
                if (placar <= 0)
                {
                    placar = 0;
                }
            }
            txtStatus.Foreground = statusTxtColor;
            txtStatus.Text = resultado;
            txtPlacar.Text ="Placar: "+ placar.ToString();
        }

        private void btnIniciar_Click(object sender, RoutedEventArgs e)
        {
            timer.Start();
            statusTxtColor = Brushes.White;
            txtStatus.Foreground = statusTxtColor;
            txtStatus.Text = "Aguarde...";
            HabilitaCarta(false);
            btnIniciar.IsEnabled = false;
            qLbl1.Visibility = qLbl2.Visibility = qLbl3.Visibility = Visibility.Collapsed;
        }

        // Habilita o click da carta
        private void HabilitaCarta( bool habilita )
        {
            carta_0.IsEnabled = carta_1.IsEnabled = carta_2.IsEnabled = habilita;
        }


        //Abre a  carta
        private void AbreCarta()
        {
            carta_0.Source = GetImagem(arr[0]);
            carta_1.Source = GetImagem(arr[1]);
            carta_2.Source = GetImagem(arr[2]);
        }

        // Fecha a carta
        private void FechaCarta()
        {
            carta_0.Source = carta_1.Source = carta_2.Source = GetImagem("back");
        }
    }
}
